Loading...
Searching...
No Matches
exceptions.hpp File Reference

defines a set of exceptions that are used by libthreadar to report error situations More...

`#include "config.h"`
`#include <string>`
`#include <vector>`
`#include <new>`
`#include <iostream>`
`#include <sstream>`

Go to the source code of this file.

## Classes

class | libthreadar::exception_base
| Pure virtual class parent of all libthreadar exceptions. More...
class | libthreadar::exception_memory
| Exception used to report memory allocation failures. More...
class | libthreadar::exception_bug
| Exception used to report webdar internal bugs. More...
class | libthreadar::exception_thread
| Exception used to report error met when manipulating threads. More...
class | libthreadar::exception_system
| Exception used to report operating system errors. More...
class | libthreadar::exception_range
| Exception used to report out or range value or argument. More...
class | libthreadar::exception_feature
| Exception used to report an non-implemented feature. More...

## Namespaces

namespace | libthreadar
| This is the only namespace used in libthreadar and all symbols provided by libthreadar are member of this namespace.

## Macros

#define | THREADAR_BUG exception_bug(__FILE__, __LINE__)
| Macro used to throw an exception_bug when execution reach that statement.

## Functions

template<class T >
exception_base * | libthreadar::cloner (void *const ptr)
| Template used by libthreadar to implement the clone() method for libthreadar exceptions.

## Detailed Description

defines a set of exceptions that are used by libthreadar to report error situations

- exception_base is a pure virtual class parent of all libthreadar exceptions
- exception_memory is used to report failure due to lack of memory
- exception_bug is used to signal a bug in libthreadar
- exception_thread is used to signal an error relative to threads (thread creation failure, etc.)
- exception_system is used to report a system error (other than thread relative one)
- exception_range is used to signal out of range parameter
- exception_feature is used to signal a non yet implemented feature

Definition in file exceptions.hpp.

## Macro Definition Documentation

## THREADAR_BUG

#define THREADAR_BUG exception_bug(__FILE__, __LINE__)

Macro used to throw an exception_bug when execution reach that statement.

Definition at line 164 of file exceptions.hpp.